;##################################################################
; Rotate Demo
; Uses Graphics.lib available at 
; http://donkey.visualassembler.com/
;
; NOTE: Only 32 bit DIB sections can be used with Graphics.lib
; If the bitmap does not meet this spec, you can convert it with
; ConvertToDIB32
;##################################################################

#include "ShowRotate.Inc"

#Define IDD_DLG1 1000

DATA SECTION
	hInstance	DD		?

	hTempBmp	DD		?
	hFixedBmp	DD		?
	angle		DD		0.0
	crPixel		DD		?

CODE SECTION

Start:
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke InitCommonControls
	invoke DialogBoxParam,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL rect		:RECT
	LOCAL hdc		:D
	LOCAL memdc		:D

	mov eax,[uMsg]
	cmp eax,WM_INITDIALOG
	jne >>.WMCOMMAND
		mov eax,360
		shl eax,16
		invoke SendDlgItemMessageA,[hwnd],1002,TBM_SETRANGE,TRUE,eax
		invoke LoadImage,[hInstance],5000,IMAGE_BITMAP,0,0,LR_CREATEDIBSECTION
		mov [hTempBmp],eax
		invoke ConvertToDIB32,eax
		mov [hFixedBmp],eax

		; This code just gets the topleft pixel color to use
		; as the fill color, looks better that way
		invoke GetDC,0
		mov [hdc],eax
		invoke CreateCompatibleDC,[hdc]
		mov [memdc],eax
		invoke SelectObject,[memdc],[hFixedBmp]
		push eax
		invoke GetPixel,[memdc],0,0
		mov [crPixel],eax
		pop eax
		invoke SelectObject,[memdc],eax
		invoke ReleaseDC,0,[hdc]
		invoke DeleteDC,[memdc]

		invoke CopyDIBImage,[hFixedBmp]
		invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,eax
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >.WMHSCROLL

		jmp >>.EXIT

	.WMHSCROLL
	cmp eax,WM_HSCROLL
	jne >>.WMCLOSE
		cmp D[hFixedBmp],0
		je >>.EXIT
			invoke SendDlgItemMessageA,[hwnd],1002,TBM_GETPOS,0,0
			mov [angle],eax
			fild D[angle]
			fstp D[angle]
			invoke Deg2Rad,[angle]
			invoke GetRotatedBitmap,[hFixedBmp],eax,[crPixel]
			invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,eax
			or eax,eax
			jz >
				invoke DeleteObject,eax
			:
			jmp >.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		invoke SendDlgItemMessageA,[hwnd],1001,STM_SETIMAGE,IMAGE_BITMAP,0
		or eax,eax
		jz >
			invoke DeleteObject,eax
		:
		invoke DeleteObject,[hFixedBmp]
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF
